
--[[
	Action Bars for Agents to use
	.starting() an action bar will display it to the specific pid for duration
	
	needs to be reactivated every round, and can be stopped manually with .stop()
]]



agent.action = {}

agent.action.bars = {}

function agent.action.start(pid, duration)
	
	
	local imgBack = image(conf.imgPath..conf.action.background, conf.action.posx, conf.action.posy, 2, pid)
	local imgBar  = image(conf.imgPath..conf.action.bar, conf.action.posx, conf.action.posy, 2, pid)
	
	agent.action.bars[pid] = { dur = duration, durMax = duration, back = imgBack, bar = imgBar }
	timerEx(duration, agent.action.stop, 1, pid)
end


function agent.action.update()
	local ratio, sizeX
	for pid, bar in ipairs(agent.action.bars) do
		ratio = bar.dur / bar.durMax;
		sizeX = (conf.action.sizex-2*conf.action.borderx)*ratio
		imagescale(bar.bar, sizeX, 1)
		imagepos  (bar.bar, (conf.action.sizex/2) + (sizeX/2), conf.action.posy, 0)
		bar.dur = bar.dur - 100 -- ms100 hook
		if (bar.dur <= 0) then
			agent.action.stop(pid)
		end
	end
end


function agent.action.stop(pid)
	if (not agent.action.bars[pid]) then return end -- already ended
	freeimage( agent.action.bars[pid].back)
	freeimage( agent.action.bars[pid].bar)
	agent.action.bars[pid] = nil
end


function agent.action.endround()
	-- Free all
	for pid, bar in ipairs(agent.action.bars) do
		freeimage( bar.back)
		freeimage( bar.bar)
		bar = 0
	end
end

hooker.normal:Hook(agent.action.endround, "endround")
hooker.normal:Hook(agent.action.update, "ms100")


