

--[[
	Draw images and hudtxt2 for each agent
	- manabar, manatxt
	- utility image + utility cd text, utility toggle borders
	
]]

--if (not agent) then return end

agent.hud = {}

agent.hud.data = {}

function agent.hud.update(pid)
	local pset = user.getSet(pid)
	local ratio = pset.mana / conf.user.manaMax
	
	-- Mana bar
	imagescale(agent.hud.data[pid].mana,
		(conf.mana.sizex-2*conf.mana.borderx)*ratio,  1)
	
	-- Mana Txt
	util.htxt2(pid, conf.mana.hid, pset.mana, conf.mana.posx, conf.mana.posy+conf.mana.txt_offy, 1, 1, 12)
	
	-- Util Cooldown
	for _,utilKey in pairs(conf.user.utilKeys) do
		if (pset.utils[utilKey].cooldown > 0) then
			local txt = string.format("%2d",pset.utils[utilKey].cooldown / 1000)
			util.htxt2(pid,conf.utilhid+utilKey,txt,conf.util[utilKey].x+conf.util.cd_offx, conf.util[utilKey].y+conf.util.cd_offy, 1, 1, 15)
		else
			util.htxt2(pid,conf.utilhid+utilKey)
		end
	end
end

function agent.hud.start(pid)
	
	local agentname = agent.current[pid]
	
	agent.hud.data[pid] = {}
	agent.hud.data[pid].utils = {}
	
	-- Draw Manabackground, Mana
	local backgr = image(conf.imgPath..conf.manaBackground,
						conf.mana.posx,
						conf.mana.posy,
						2)
	agent.hud.data[pid].background = backgr; 
	
	
	local mana = image(conf.imgPath..conf.manaBar,
						conf.mana.posx,
						conf.mana.posy,
						2, pid)
	
	agent.hud.data[pid].mana = mana
		
	-- Draw Ult Kills
	util.htxt2(pid, conf.ultpoints.hids[1], conf.ultpoints.lbl, conf.ultpoints.x, conf.ultpoints.y, 2)
	agent.hud.updateUltPts(pid)
	
	-- Draw Util Images
	for _,utilKey in pairs(conf.user.utilKeys) do
		local util = image(conf.imgPath..(conf.agents)..agentname..conf.util[utilKey].post,
							conf.util[utilKey].x, 
							conf.util[utilKey].y, 2, pid)
		
		agent.hud.data[pid].utils[utilKey] = { img = util }
	end
	
	
	agent.hud.drawIcon(pid)
end

-- ICON being the player hat
function agent.hud.drawIcon(pid)
	-- Draw Agent icon
	if (agent.data[pid].icon) then
		freeimage(agent.data[pid].icon)
	end
	
	
	local icon = image(conf.imgPath..(conf.agents)..agent.current[pid]..conf.util.agentIconPost,
				2, 0, 200+pid)
	
	
	agent.hud.data[pid].icon = icon;
end

function agent.hud.updateUltPts(pid)
	local txt =  user.getSet(pid).ultPoints.."/"..agents[agent.current[pid]].utils[3].ultCost
	util.htxt2(pid, conf.ultpoints.hids[2], txt, conf.ultpoints.x, conf.ultpoints.y)
end

function agent.hud.stop(pid)
	
	local data = agent.hud.data[pid]
	if (not data) then return end -- ONLY FOR LISTENserver?
	-- Freeimage mana
	freeimage(data.mana)
	freeimage(data.background)
	util.htxt2(pid, conf.mana.hid)
	
	-- Freeimage Ult Points
	util.htxt2(pid, conf.ultpoints.hids[1])
	util.htxt2(pid, conf.ultpoints.hids[2])
	
	
	for _,utilKey in pairs(conf.user.utilKeys) do
		-- Free utils
		freeimage(data.utils[utilKey].img)
		util.htxt2(pid,conf.utilhid+utilKey)
		
		-- Free Borders
		if (agent.hud.data[pid].utils[utilKey].borders) then
			for borderId,_ in pairs(agent.hud.data[pid].utils[utilKey].borders) do
				agent.hud.undrawBorder(pid, utilKey, borderId)
			end
		end
	end
	--^--freeimage(agent.hud.data[pid].icon)
	
end


function agent.hud.drawBorder(pid, utilKey, borderId)
	local img = image(conf.imgPath..conf.utilBorders[borderId], conf.util[utilKey].x, conf.util[utilKey].y, 2)
	imageblend(img, 1)
	if (not agent.hud.data[pid].utils[utilKey].borders) then agent.hud.data[pid].utils[utilKey].borders = {} end
	agent.hud.data[pid].utils[utilKey].borders[borderId] = img
end

function agent.hud.undrawBorder(pid, utilKey, borderId)
	freeimage(agent.hud.data[pid].utils[utilKey].borders[borderId])
	agent.hud.data[pid].utils[utilKey].borders[borderId] = nil
end

hooker.normal:Hook(agent.hud.updateUltPts, "agentkill")
--hooker.normal:Hook(agent.hud.onUtilUse, "agentutil")


