


agents["gnuk"] =
{
	name = "Gnuk",
	health = 100,
	speed = -1,
	desc = "Franzy Level Multiplies Damage Output",
	
	ultwpn = 47,
	franzyMin = 0.0,
	franzyMax = 1.0,
	franzyInc = 0.05,
	franzySpeed = 20,
	
	transfers = {
		["glowPath"] = "gfx/sprites/flare2.bmp",
	},
	
	onInit = function(self)
		local k = {}
		k.name = "gnuk"
		-- Agent Hooker: hit hook, and the second parameter of the hit hook has to be the agent "gnuk"
		hooker.agent:Hook(self.onHit , "hit",2,k.name)
		-- Time Hooker: Call Hook for every living pid with agent.current[pid] == 'gnuk'
		-- Although it is a time hook, it will be called with an pid parameter, and be called multiple times each second,ms100. (Once for each pid)
		hooker.time:Hook(self.drawFranzy, "notice", hooker.agent, k)
		hooker.time:Hook(self.utils[1].onUpdate, "update", hooker.agent, k)
	end,
	
	-- called on selection and endround!
	onSelect = function(data, pid)
		data.isFranzying = false
		data.isSpeeding = false
		data.franzy = agents["gnuk"].franzyMin
		
		agents["gnuk"].setSpeed(pid, data.franzy)
	end,
	
	setSpeed = function(pid, franzy)
		local newSpeed = agents["gnuk"].speed-(agents["gnuk"].franzySpeed* franzy)
		parse("speedmod "..pid.." "..newSpeed)
	end,
	
	
	onHit = function(data, vic, pid, wpn,hp,ap,raw)
		
		local vicHealth = player(vic,"health")
		local newHealth = vicHealth - (data.franzy+1)*hp
		if (newHealth <= 0) then
			parse('customkill '..pid..' "'..itemtype(wpn,"name")..','..util.wpntype2killimg(wpn)..'" '..vic)
		else
			parse("sethealth "..vic.." "..newHealth)
			
		end
		return 1;
		
	end,
	
	onSpawn = function(data, pid)
		agents["gnuk"].drawFranzy(data, pid)
	end,
	
	drawFranzy = function(data, pid)
		agent.info.update(pid, "Damage x"..(data.franzy+1))
	end,
	
	-- Abilities
	utils = {
		[1] = {
			name = "Franzy",
			desc = "(Toggle) Gain Franzy/Lower Speed",
			manaCost = 36,
			maxUse = 9999, -- unlimited uses
			cooldown = 4000,
			kind = "TOGGLE",
			
			explanation = {
				"[F2] Toggle: In/Decrease your Franzy Level",
				"The higher your Franzy Level, the higher the damage",
				"But it also slows you down a lot",
			},
			
			isTriggerable = function(data, pid)
				if (data.isSpeeding) then
					return false;
				else
					return true;
				end

			end,
			
			onTrigger = function(data, pid)
				data.isFranzying = true
			end,
			
			onUntrigger = function(data, pid)
				data.isFranzying = false
			end,
			
			
			onUpdate = function(data, pid)
				-- Do nothing when speeding or ulting
				if (data.isSpeeding) then return end
				if (data.preBlink) then return end
				
				-- Decide if add or substract
				local inc = agents["gnuk"].franzyInc
				if (not data.isFranzying) then
					inc = -inc
				end
				
				-- Update Franzy Value and speed
				data.franzy = data.franzy + inc
				
				if (data.franzy >= agents["gnuk"].franzyMax) then
					data.franzy = agents["gnuk"].franzyMax
				elseif (data.franzy <= agents["gnuk"].franzyMin) then
					data.franzy = agents["gnuk"].franzyMin
				end
				agents["gnuk"].setSpeed(pid, data.franzy)
			end
			
			
		},
		[2] = {
			name = "Speed",
			desc = "Ignore Slow temporarly",
			manaCost = 1,
			maxUse = 11,
			cooldown = 6000,
			duration = 2500,
			kind = "DURATION",
			
			
			explanation = {
				"[F3] Temporarly ignore Movementspeed Debuff",
				"It is best used when having maximum Franzy Level"
			},

			onTrigger = function(data, pid)
				local self = agents["gnuk"]
				data.isSpeeding = true
				agents["gnuk"].setSpeed(pid, 0)
				
				local img = image(agents["gnuk"].transfers.glowPath,1,0,100+pid)
				imagecolor(img,255,255,255)
				imageblend(img,1)
				imagealpha(img,0.5)
				data.speedImg = img;
			end,
			
			onUntrigger = function(data, pid) 
				data.isSpeeding = false
				data.franzy = agents["gnuk"].franzyMin;
			
				
				-- reset speed
				agents["gnuk"].utils[1].onUpdate(data, pid)
				
				if (data.speedImg) then
					freeimage(data.speedImg)
				end
			end,
			
		},
	
		[3] = {
			name = "Flash on Cursor",
			desc = "Shoot Rocket and go back",
			manaCost = 90,
			ultCost = 5,
			maxUse = 1,
			cooldown = 20000,
			kind = "CLICK",
			
			explanation = {
				"[F4] Teleports you to your cursor location",
				"Shoot a rocket and teleports you right back",
			},
			
			blinkTime = 700,
			
			onTrigger = function(data, pid)
				data.preBlink = {
					x = player(pid,"x"),
					y = player(pid,"y"),
					wpn = player(pid,"weapontype"),
					speed = player(pid,"speedmod"),
				}
				
				parse("equip "..pid.." "..agents["gnuk"].ultwpn)
				parse("setweapon "..pid.." "..agents["gnuk"].ultwpn)
				parse("setpos "..pid.." "..player(pid,"mousemapx").." "..player(pid,"mousemapy"))
				parse("speedmod "..pid.." -100")
				timerEx(agents["gnuk"].utils[3].blinkTime, agents["gnuk"].utils[3].onFallback, 1, data, pid)
				
				agent.action.start(pid, agents["gnuk"].utils[3].blinkTime)
			end,
			
			
			onFallback = function(data, pid)
				if (not data.preBlink) then return end -- round ended already
				
				parse("setpos "..pid.." "..data.preBlink.x.." "..data.preBlink.y)
				parse("strip "..pid.." "..agents["gnuk"].ultwpn)
				parse("setweapon "..pid.." "..data.preBlink.wpn)
				parse("speedmod "..pid.." "..data.preBlink.speed)
				data.preBlink = nil
			end
			
		},
	},

}

