agents["sniffer"] =
{
	name = "Sniffer",
	health = 100,
	speed = -1,
	desc = "Tactical Utilities",
	
	
	transfers = {
		["tacMarkerPath"] = conf.imgPath..conf.agents.."sniffer_tacmarker.png",
	},
	
	
	tacWpn = 78, -- CLAW
	tacMaxPlaced = 5, -- Maximum TAC Gear placements per round
	
	
	tacticals = {
		52,
		53,
		54,
	},
	
	
	onInit = function(self)
		hooker.agent:Hook(self.onHit , "hit",2,"sniffer") -- src
		hooker.agent:Hook(self.utils[1].onAttack, "attack",1,"sniffer")
		hooker.agent:Hook(self.utils[1].onAttack2, "attack2",1,"sniffer")
	end,
	
	-- called on selection and endround!
	onSelect = function(data, pid)
		-- Player still in ult on endround
		if (data.preUlt) then
			-- Hooks
			hooker.agent:Remove(agents["sniffer"].utils[3].onAttack, "attack",1,"sniffer")
			hooker.agent:Remove(agents["sniffer"].utils[3].onWalkover, "walkover",1,"sniffer")
			data.preUlt = nil
		end
		
		-- Reset normal values
		data.tacPlaced = 0
		data.tacPos = {}
		data.currTacPos = data.currTacPos or 1
		
	end,

	onSpawn = function(data, pid)
		agent.info.update(pid, "TAC Gear: "..itemtype(agents["sniffer"].getTacWpn(data.currTacPos),"name"))
		return agents["sniffer"].tacWpn;
	end,
	
	onHit = function(data, vic, pid, wpn,hp,ap,raw)
		if (wpn == agents["sniffer"].tacWpn) then
			msg2(pid,conf.chatWarning.."You cant use your "..itemtype(wpn, "name").." as a weapon")
			return 1;
		end
	end,
	
	
	cycleTacticals = function(data, pid)
		if (data.currTacPos < #agents["sniffer"].tacticals) then
			data.currTacPos = data.currTacPos + 1
		else
			data.currTacPos = 1
		end
	end,
	
	
	getTacWpn = function(tacPos)
		return agents["sniffer"].tacticals[tacPos]
	end,
	
	
	-- Abilities
	utils = {
		[1] = {
			name = "Swap Equipment",
			desc = "Select your current Tactical Gear",
			manaCost = 1,
			maxUse = 9999, -- unlimited uses
			cooldown = 500,
			kind = "CLICK",
			
			explanation = {
				"[F2] Swap between your current Tactical Equipment (Flash, Smoke, Molotov)",
				"Hold Claw and Attack (Leftclick) to place Tactical Equipment on Cursor Location",
				"Hold Claw and Attack2 (Rightclick) to trigger all of your currently placed Tactical Equipment",
			 },
			
			isTriggerable = function(data, pid)
				-- Cant use F2 when ulting...
				if (data.preUlt) then
					return false;
				else
					return true;
				end

			end,
			
			onTrigger = function(data, pid)
				agents["sniffer"].cycleTacticals(data, pid)
				agent.info.update(pid, "TAC Gear: "..itemtype(agents["sniffer"].getTacWpn(data.currTacPos),"name"))
			end,
			
			-- Remember clicked position
			onAttack = function(data, pid)
				if (data.preUlt) then return end
				if (agents["sniffer"].tacWpn == player(pid,"weapontype")) then
					if (agents["sniffer"].tacMaxPlaced > data.tacPlaced) then
						-- Player has CLAW & still not maxed out his placed pos
						local mousex = player(pid,"mousemapx")
						local mousey = player(pid,"mousemapy")
						
						data.tacPlaced = data.tacPlaced + 1
						local img = image(agents["sniffer"].transfers.tacMarkerPath, mousex, mousey, 0)
						
						table.insert(data.tacPos, { tacWpn = agents["sniffer"].getTacWpn(data.currTacPos), x = mousex, y = mousey, image = img})
					else
						msg2(pid,conf.chatWarning.."You placed the max. amount of TAC Charges this round! (Max: "..agents["sniffer"].tacMaxPlaced..")")
					end
				end
			end,
			
			-- Release all remembered click positions
			onAttack2 = function(data, pid)
				if (data.preUlt) then return end
				if (agents["sniffer"].tacWpn == player(pid,"weapontype")) then
					if (#data.tacPos <= 0) then
						msg2(pid,conf.chatWarning.."You have to place TAC Charges with normal Attacks first!")
						return;
					end
					for _, tacData in ipairs(data.tacPos) do
						freeimage(tacData.image)
						parse("spawnprojectile "..pid.." "..tacData.tacWpn.." "..tacData.x.." "..tacData.y.." 1 "..util.getRandomNumber(1,360))					
					end
					data.tacPos = {}
				end
			end,
			
		},
		[2] = {
			name = "Wall Off",
			desc = "Place a Breakable Wall on Cursor",
			manaCost = 40,
			maxUse = 4,
			cooldown = 1500,
			kind = "CLICK",
			
			explanation = {
				"[F3] Spawn a breakable wall on cursor location",
			 },
			
			wallkind = 5,
			
			isTriggerable = function(data, pid)
				local xtile = util.pixel2tile(player(pid,"mousemapx"))
				local ytile = util.pixel2tile(player(pid,"mousemapy"))
				if (tile(xtile,ytile,"walkable") and util.getPlayerOnTile(xtile, ytile) <= 0) then
					data.wallx = xtile;
					data.wally = ytile;
					return true
				end
				return false
			end,

			onTrigger = function(data, pid)
				parse("spawnobject "..agents["sniffer"].utils[2].wallkind.." "..data.wallx.." "..data.wally.." 0 0 "..player(pid,"team").." "..pid)
				data.wallx = nil
				data.wally = nil
			end,
		},
	
		[3] = {
			name = "Devastating Explosions",
			desc = "Get invisble and fast: Place a bomb and fall back",
			manaCost = 90, -- kills
			ultCost = 6,
			maxUse = 1,
			cooldown = 0,
			kind = "CLICK",
			
			explanation = {
				"[F4] You get super fast, invincible, cant use your other abilities and do no damage",
				"Dive into the enemy and call an airstrike on your location",
				"After some time or attack you teleport back",
			 },
			
			chargeTime = 4500,
			explosionDistance = 60,
			explosionDelay = 1500,
			explosionTypes = {
				51
			},
			

			explode = function(data, pid)
				if (not data.ultPos) then return end
				local explosionDist = agents["sniffer"].utils[3].explosionDistance
				local positions = {}
				
				for direction=1,2 do
					table.insert(positions, {
						-- TOP
						x = data.ultPos.x,
						y = data.ultPos.y - explosionDist,
					})
				
					table.insert(positions, {
						-- TOP LEFT
						x = data.ultPos.x - explosionDist,
						y = data.ultPos.y - explosionDist
					})
					
					table.insert(positions, {
						-- LEFT
						x = data.ultPos.x - explosionDist,
						y = data.ultPos.y,
					})
					
					table.insert(positions, {
						-- BOT LEFT
						x = data.ultPos.x - explosionDist,
						y = data.ultPos.y + explosionDist,
					})
					
					-- SWAP directions (TOP -> BOTTOM, LEFT -> RIGHT)
					explosionDist = -explosionDist

				end
				
				
				for _,explosion in ipairs(positions) do
					parse("spawnprojectile "..pid.." "..agents["sniffer"].utils[3].explosionTypes[util.getRandomNumber(1,#agents["sniffer"].utils[3].explosionTypes)].." "..explosion.x.." "..explosion.y.." 1 1")
				end
				
				data.ultPos = nil
			
			end,
			
			
			onTrigger = function(data, pid)
				data.preUlt = {
					x = player(pid,"x"),
					y = player(pid,"y"),
					wpns = playerweapons(pid),
					speed = player(pid,"speedmod"),
				}
				-- Strip all weapons
				for _, wpn in pairs(data.preUlt.wpns) do
					if (wpn ~= agents["sniffer"].tacWpn and wpn ~= 55) then -- 55 = bomb, console error suppression
						parse("strip "..pid.." "..wpn)
					end
				end
				
				agent.action.start(pid, agents["sniffer"].utils[3].chargeTime)
				
				-- Stealth Suit, speed
				parse("equip "..pid.." 84")
				parse("speedmod "..pid.." 80")
				parse("setweapon "..pid.." "..agents["sniffer"].tacWpn)
				
				-- Hooks
				hooker.agent:Hook(agents["sniffer"].utils[3].onAttack, "attack",1,"sniffer")
				hooker.agent:Hook(agents["sniffer"].utils[3].onWalkover, "walkover",1,"sniffer")
				
				timerEx(agents["sniffer"].utils[3].chargeTime,agents["sniffer"].utils[3].onFallback,1,data, pid)
			end,
			
			onWalkover = function(data, pid)
				return 1
			end,
			
			onAttack = function(data, pid)
				data.ultPos = {
					x = player(pid,"x"),
					y = player(pid,"y"),
				}
				
				
				-- Teleport back after calling Airstrike
				agents["sniffer"].utils[3].onFallback(data, pid)
				
			end,
			
			onFallback = function(data, pid)
				if (not data.preUlt) then return end -- round ended already, so ignore this
				
				-- If player didnt attack manually
				if (not data.ultPos) then
					data.ultPos = {}
					data.ultPos.x = player(pid,"x")
					data.ultPos.y = player(pid,"y")
				end
				
				-- Stealth Suit (84), speed,
				parse("strip "..pid.." 84")
				parse("speedmod "..pid.." "..data.preUlt.speed)
				parse("setpos "..pid.." "..data.preUlt.x.." "..data.preUlt.y)
				
				for _,wpn in ipairs(data.preUlt.wpns) do
					parse("equip "..pid.." "..wpn)
				end
				
				-- Hooks
				hooker.agent:Remove(agents["sniffer"].utils[3].onAttack, "attack")
				hooker.agent:Remove(agents["sniffer"].utils[3].onWalkover, "walkover")
				
				
				
				timerEx(agents["sniffer"].utils[3].explosionDelay, agents["sniffer"].utils[3].explode,1,data,pid)
				
				agent.action.stop(pid)
				data.preUlt = nil
			end,
			
		},
	},

}
