

agents["veyne"] =
{
	name = "Veyne",
	health = 100,
	speed = -1,
	desc = "Mobile Soul Hunter",
	
	onInit = function(self)
		
	end,
	
	onSelect = function(data, pid)
		data = {}
		
		
	end,
	
	-- Abilities
	utils = {
		[1] = {
			name = "Tumble",
			desc = "Blink on cursor",
			manaCost = 40,
			maxUse = 2,
			cooldown = 1500,
			kind = "CLICK",
			
			explanation = {
				"[F2] Blink onto your Cursor Position",
				"You have to have your cursor CLOSE to your player to work!",
			},
			
			maxDistance = 128,
			
			isTriggerable = function(data, pid)
				local mousex = player(pid,"mousemapx")
				local mousey = player(pid,"mousemapy")
				local dx = player(pid,"x") - mousex
				local dy = player(pid,"y") - mousey
				local dist = math.sqrt( (dx*dx) + (dy*dy))
				if (dist <= agents["veyne"].utils[1].maxDistance) then
					local tilemx = util.pixel2tile(mousex)
					local tilemy = util.pixel2tile(mousey)
					if (tile(tilemx, tilemy,"walkable")) then
						data.blinkx = tilemx;
						data.blinky = tilemy;
						return true;
					end
				end
				msg2(pid,conf.chatWarning.."Mouse too far away from player?")
				return false;
			end,
			
			onTrigger = function(data, pid)
				--blinkxy CANT be nil here, because "isTriggerable" only sets it, when it is triggerable
				parse("setpos "..pid.." "..((data.blinkx*32)+16).." "..((data.blinky*32)+16))
				data.blinkx = nil
				data.blinky = nil
			end,
			
		},
		[2] = {
			name = "SILENCE Enemys",
			desc = "Cant cast spells",
			manaCost = 100,
			maxUse = 10,
			cooldown = 2000,
			duration = 1500,
			kind = "DURATION",
			
			
			explanation = {
				"[F3] Attacks apply 'SILENCE' to your victim for a short duration",
				"Best used for hit-detection, as you hear hitmarker sounds",
			},
			
			silenceDuration = 100,
			
			onTrigger = function(data, pid)
				hooker.agent:Hook(agents["veyne"].utils[2].silenceHit,"hit",2,"veyne")
			end,
			
			
			silenceHit = function(data, vic, pid)
				cc.trigger(vic,"SILENCE",agents["veyne"].utils[2].silenceDuration)
				parse('sv_sound2 '..pid..' "materials/glass1.wav"')
			end,
		
			onUntrigger = function(data, pid)
				hooker.agent:Remove(agents["veyne"].utils[2].silenceHit,"hit")
			end,
			
		},
	
		[3] = {
			name = "Helpless",
			desc = "STUN all + BLIND yourself",
			manaCost = 60, 
			ultCost = 5,
			maxUse = 1,
			cooldown = 20,
			kind = "CLICK",
			
			explanation = {
				"[F4] Apply STUN+NoATK to all enemys within a radius around you after a few seconds",
				"You will be blind, but your enemies are fully incapacitated",
				"Note: Your enemys need to STAY in range when you ULT until your ULT finished!",
				"Best used with a teammate, because you get blinded",
			},
			
			chargeDuration = 2500,
			chargeRadius = 90,
			
			ccDuration = 2500,
			blindDuration = 4800,
			
			onTrigger = function(data, pid)
				
				data.preUltList = closeplayers(player(pid,"x"),
									player(pid,"y"),
									agents["veyne"].utils[3].chargeRadius,
									util.getOppositeTeam(player(pid,"team")))
				
				timerEx(agents["veyne"].utils[3].chargeDuration, agents["veyne"].utils[3].onFullyBind, 1, data, pid)
			end,
			
			
			onFullyBind = function(data, pid)
				if (not data.preUltList) then return end -- ulted just before endround (veyne.onSelect resets data)
				local onUltList = closeplayers(player(pid,"x"),
									player(pid,"y"),
									agents["veyne"].utils[3].chargeRadius,
									util.getOppositeTeam(player(pid,"team")))
			
				-- Only bind people in radius onTrigger and still onFullyBind timings
				local bindedPlayers = util.tableMatch(data.preUltList, onUltList)
				
				-- Bind all individuals
				for _,vic in pairs(bindedPlayers) do
					cc.trigger(vic, "NoATK", agents["veyne"].utils[3].ccDuration)
					cc.trigger(vic, "STUN", agents["veyne"].utils[3].ccDuration)
				end
				
				-- Bind Veyne
				cc.trigger(pid, "BLIND", agents["veyne"].utils[3].blindDuration)
			end,
		},
	},
}





