cc = {}
cc.kinds = {
	--[[
	["KIND"] = {
	
		
		// data is the [id] specific data you returned on getData(id)
		
		
		// All methods below get called automaticly, when pid is affected by CC
		
		onInit(self),			-- only once (hook here! e.g.: Lifesteal needs 'hit' hook)
		getData(id,data),		-- before applying CC (only used, when the user goes 'advanced-mode'
		onTrigger(id,data),		-- when applying CC
		
		Note: Time's exact names are element from conf.hookTimes
		ms100(id, data),
		...
		update(id,data),
		
		
		
		
		
		onUntrigger(id,data),	-- on very last CC (only called, when user goes 'boring-mode')
		
		
		Hooks specified in hookercc and .added will trigger only! if the specified pid is affected
		
		
	}
	
	
	]]
	["Lifesteal"] = {
		desc = "Regain hit dmg as life",
		
		getData = function()
			return 1.0;
		end,
		
		onHit = function(data, vic,src,hpdmg)
			msg("+health")
			parse("sethealth "..src.." "..player(src,"health")+(hpdmg*data))
		end,
		
		onInit = function(self) --> self being here cc.kinds["Lifesteal"]
			hooker.cc:Hook(self.onHit,"hit",2,"Lifesteal") -- "src" (2nd arg) is important
		end,
		
	},
	["NoATK"] = {
		desc = "Can't fire any weapon and do not damage!",
		--type(data) = bool = [true/false]
		
		getData = function(id)
			return player(id,"weapontype")
		end,
		
		onHit = function()
			msg("[NoATK] Your attacks dont do damage!")
		end,
		
		onAttack = function(id)
			msg2(id,"Are u stupid?")
		end,
		
		onTrigger = function(id)
			parse("setweapon "..id.." 50")
		end,
		
		
		update = function(data, id)
			parse("setweapon "..id.." 50")
		end,
		
		onUntrigger = function(data, id)
			parse("setweapon "..id.." "..data)
		end,
		
		onInit = function(self) --> self being here cc.kinds["NoATK"]
			hooker.cc:Hook(self.onHit,"hit",2,"NoATK") -- "src" (2nd arg) is important
			--hooker.cc:Hook(self.onAttack,"attack",1,"NoATK")
		end,
	},
	["KNOCKBACK"] = {
		desc = "Get pushed back",
		
		
		-- Knockback Data usually provided by customer... // MADE FOR DEBUG MENU
		getData = function(pid)
			result = {
				duration = 2000,
				stepAmount = 200,
				x= player(pid,"x"),
				y= player(pid,"y"),
				dx=util.getRandomNumber(-3, 3),
				dy=util.getRandomNumber(-3, 3),
				onWall = function(pid)
					msg2(pid,"You got backknocked against a wall (hot) (might not)")
				end,
			}
			return result
		end,
		
		onTrigger = function(pid, data)
			msg("KNOKCBACK: "..data.duration.." "..data.dx)
			data.stepDuration = data.duration / data.stepAmount
			timerEx(data.stepDuration,"cc.kinds.KNOCKBACK.onStep",1,pid,data)
		end,
		
		
		onUntrigger = function(pid, data)
			
		
		end,
		
		onStep = function(pid, data)
			-- new position
			data.x = data.x + data.dx
			data.y = data.y + data.dy
			
			-- new position as tile
			local xtile = util.pixel2tile(data.x)
			local ytile = util.pixel2tile(data.y)
			
			-- is new position NOT walkable?
			if (not tile(xtile, ytile, "walkable")) then
				if (data.onWall) then
					data.onWall(pid)
				end
				if (debug) then
					print("CC [KNOCKBACK] OnWallTrigger")
				end
				data.stepAmount = 0; -- stop run
			else
				parse("setpos "..pid.." "..data.x.." "..data.y)
			end
			
			
			-- next run?
			if (cc.active[pid]["KNOCKBACK"].stepAmount > 0) then
				cc.active[pid]["KNOCKBACK"].stepAmount = cc.active[pid]["KNOCKBACK"].stepAmount - 1
				timerEx(data.stepDuration, "cc.kinds.KNOCKBACK.onStep",1,pid,data)
			else
				cc.untrigger(pid,"KNOCKBACK")
			end
		end,
		
		
	},
	["STUN"] = {
		desc = "Cant Move",
		
		getData = function(pid, data)
			if (data == nil) then
				return { player(pid,"speedmod") }
			else
				-- if already on STUN: Save old speedmod, not the current one (for concusive stuns)
				return data
			end
		end,
		
		onTrigger = function(id)
			parse("speedmod "..id.." -100")
		end,
		
		onUntrigger = function(id, data)
			print(tostring(data))
			parse("speedmod "..id.." "..data[1])
		end,
	},
	["IGNITE"] = {
		desc = "Take Damage",
		dmgPerSec = 1,
		
		update = function(data, pid)
			parse("sethealth "..pid.." "..player(pid,"health")-cc.kinds.IGNITE.dmgPerSec)
		end
	},
	["BLIND"] = {
		desc = "Cant see",
		
		getData = function(pid, data)
			-- Create table when not already existing
			if (data == nil) then
				data = image(conf.ccMedia["BLIND"][1],300,300,2)
				imagescale(data,400,400)
				if (debug) then
					print("CC [BLIND]: Created image ("..data..") for pid="..pid)
				end
				return data
			end
			return cc.active[pid]["BLIND"]
		end,

		onUntrigger = function(pid, data)
			if (type(data) == "number") then
				if (debug) then
					print("CC [BLIND]: Released image ("..data..") for pid="..pid)
				end
				freeimage(data)
				data = nil;
			end
		end,
		
	
	},
	["SILENCE"] = {
		desc = "No Abilities",
	
	
		
	},
	["DEATH"] = {
		desc = "Double the Damage",
		
		-- user provided data: damageMultiplier
		onTrigger = function(pid)
		
		end
	},
	
	["DODGE"] = {
		desc = "Dodge normal shots",
	
	},
	
	--[[
	["WARPED"] = 4,
	
	]]
	

}
--eof

