--[[
	Config file. 
	- Use this for checking hudtxt ids and other values
]]

conf = {
	
	-- USGN Numbers in here have access to Debug Menu (T) when main.debug = true
	admins = {1, 51028},	-- alternativly, overwrite util.isAdmin(pid) to use your own admin system
	
	debugKey = "T",			-- addbind key, only used when debug=True
	
	
	
	path = "sys/lua/valo/",
	colorDofile = "\169120120080Dofile: ",
	colorWarning= "\169255000000[Warning] ",
	chatWarning= "\169255000000",

	teamColor = {
		[1] = "\169200000000",
		[2] = "\169000000255",
	},
	
	maps = "maps/",
	
	map = {
		buyborder = "buyb",
		
	},
	
	
	imgPath = "gfx/valo/",
	sfxPath = "sfx/valo/",
	tempPath = "sys/lua/valo/temp/",
	agents = "agents/",
	
	
	utilBorders = { 
		["TOGGLE"] = "toggle.png",
		["NOUSE"] = "nouse.png",
		["ACTIVE"] = "active.png",
	},

	utilKind = {
		-- Calls util.onUntrigger() after util.duration
		["DURATION"] = {
			onTrigger = function(pid, utilKey, util)
				agent.hud.drawBorder(pid, utilKey, "ACTIVE")
				util.onTrigger(agent.data[pid], pid)
				timerEx(util.duration, conf.utilKind.DURATION.onUntrigger, 1, pid, utilKey, util)
			end,
			
			onUntrigger = function(pid, utilKey, util)
				agent.hud.undrawBorder(pid, utilKey, "ACTIVE")
				agent.onUntrigger(pid, utilKey, util)
			end,
		},
		
		-- Only calls util.onTrigger() 
		["CLICK"] = {
			onTrigger = function(pid, utilKey, util)
				util.onTrigger(agent.data[pid], pid)
			end,
		},
		
		-- Presses util.onTrigger() and .onUntrigger() respectivly
		["TOGGLE"] = {
			onTrigger = function(pid, utilKey, util)
				-- .isActive is already swapped here
				if (user.getSet(pid).utils[utilKey].isActive) then
					agent.hud.drawBorder(pid, utilKey, "TOGGLE")
					util.onTrigger(agent.data[pid], pid)
				else
					agent.hud.undrawBorder(pid, utilKey, "TOGGLE")
					agent.onUntrigger(pid, utilKey, util)
				end
			
			end,
			
		},
	},

	manaBar = "mana.png",
	manaBackground = "manaBackground.png",
	
	action = {
		bar = "actionbar.png",
		background = "actionbarBackground.png",
		posx = 425,
		posy = 400,
		
		sizex = 300,
		sizey = 12,
		
		borderx = 3,
		bordery = 2,
	},
	
	info = {
		hid = 110,
		x = 425,
		y = 350,
		color = "\169255255255",
		
		ult = {
			hid = 10,
			x = 425,
			y = 20,
			dur = 2000,
		},
	},
	utilhid = 100, -- +3 for util cd
	util = {
		[1] = {
			x = 350,
			y = 400,
			post = "_1.png",
		},
		[2] = {
			x = 425,
			y = 400,
			post = "_2.png",
		},
		[3] = {
			x = 500,
			y = 400,
			post = "_3.png",
		},
		agentIconPost = "_icon.png",
		cd_offx = -1,
		cd_offy = 0,
	},
	
	ultpoints = {
		x = 550,
		y = 440,
		hids = {
			[1] = 50,
			[2] = 51,
		},
		lbl = "\169255000000ULT Points: ",
	},
	
	mana = {
		-- size depends on manaBackground.png!
		sizex = 300,
		sizey = 12,
		borderx = 3,
		bordery = 2,
		posx = 425,
		posy = 430,
		hid = 120,
		txt_offy = 0,
	},
	
	
	startMoney = 4000,
	
	
	
	
	
	
	hookdict = {
		--[key] = value
		--[own hookname] = "original hookname", the Hooker will replace your hook if hook==key then hook=value 
		["update"] = "ms100",
		["tick"] = "always",
		["notice"] = "second",
	},
	
	-- usefull for CC Kinds!
	hookTimes = { "update", "tick", "notice"},
	
	-- Custom hook list
	chooks = {
		["endbuy"] = {},		-- buytime ended
		["statechange"] = {},	-- env.state changes
		["agentutil"] = {},		-- agent uses abilities
		["agentkill"] = {},		-- agent kills player
		["agentultready"] = {},	-- agent is able to use ult now
		["agentdie"] = {},
	},
	
	buytime = 0.1,
	
	
	ccMedia = {
		["BLIND"] = {"gfx/valo/nouse.png"},
		
	},
	
	
	
}


function initgamesettings()
	msg("[CONF] Overwriting game settings")
	parse("mp_buytime "..conf.buytime)
	
	for k,v in pairs(player(0,"tableliving")) do
		parse("spawnplayer "..v.." 300 300")
	end
	
	--parse("sv_restart 5")
	parse("mp_buymenu ''")
	parse("mp_startmoney "..conf.startMoney)
	parse("mp_hudscale 1")
end


-- see user.lua
conf.user = {
	manaMax = 100,
	manaRegain = 1,
	cooldownRegain = 100,
	

	-- Do not edit utilKeys
	utilKeys = {1,2,3}
}


if (debug) then
	conf.cclist = {
	"Lifesteal",
	"NoATK",
	"KNOCKBACK",
	"STUN",
	"IGNITE",
	"BLIND",
	"SILENCE",
	"DEATH",
	"DODGE"
	}
end
