
--[[
	Creates server.lst for you

]]


content = {}

function content.generateAll()
	content.serverlist()
	content.agentinfo()
	content.agentinfoFull()
end

function content.serverlist()
	file = io.open (conf.tempPath.."servertransfer.lst",'w')
	
	file:write("//AUTOMATICLY CREATED SERVERTRANSFER.LST VIA DEBUG MENU. VERSION: "..main.version,"\n")
	
	-- Borders
	for k,v in pairs(conf.utilBorders) do
		file:write(conf.imgPath..v, "\n")
	end
	
	-- Mana
	file:write(conf.imgPath..conf.manaBar, "\n")
	file:write(conf.imgPath..conf.manaBackground, "\n")
	
	-- Actionbar
	file:write(conf.imgPath..conf.action.bar, "\n")
	file:write(conf.imgPath..conf.action.background, "\n")
	
	
	-- Agents
	file:write("// AGENT DATA", "\n")
	for aname, agent in pairs(agents) do
		-- Agents utilities
		for utilid, utilconf in ipairs(conf.util) do
			file:write(conf.imgPath..conf.agents..aname..utilconf.post, "\n")
		end
		
		
		-- Agents transferables (custom agent files)
		if (agent.transfers) then
			for _,filepath in pairs(agent.transfers) do
				file:write(filepath, "\n")
			end
		end
		
		-- Agent Icons
		file:write(conf.imgPath..conf.agents..aname..conf.util.agentIconPost, "\n")
		
		-- sfx? todo...
	end
	
	-- CCs
	file:write("// CC DATA", "\n")
	for cckind, ccmedia in pairs(conf.ccMedia) do
		for _, v in pairs(ccmedia) do
			file:write(v, "\n")
		end
	end
	
	file:close()
end


function content.agentinfo()
	file = io.open (conf.tempPath.."agentinfo.txt",'w')
	
	file:write("AGENT SUMMARY\n")
	for aname, agent in pairs(agents) do
		file:write("[",agent.name,"] ", agent.desc, "\n")
		
		for utilKey, util in ipairs(agent.utils) do
			file:write("[F",tostring(utilKey+1),"] ",util.name, " ::: ", util.desc, "\n")
		end
		file:write("\n")
	end
	file:close()
end


function content.agentinfoFull()
	file = io.open (conf.tempPath.."agentinfoFull.txt",'w')
	
	file:write("AGENT STATS\n")
	local utilStr

	for aname, agent in pairs(agents) do
		file:write("[",agent.name,"] ", agent.desc, "\n")
		
		for utilKey, util in ipairs(agent.utils) do
			if (util.isToggle) then
				file:write("[F",tostring(utilKey+1),"] Toggle: ",util.name, " ::: ", util.desc, "\n")
			else
				file:write("[F",tostring(utilKey+1),"] ",util.name, " ::: ", util.desc, "\n")
			end
			
			
			if (utilKey ~= 3) then
				file:write("Max uses: ", util.maxUse)
			else
				file:write("ULT Costs: ",util.ultCost)
			end
			file:write(", Cooldown: ",util.cooldown)
			if (util.duration) then
				file:write(", Duration: ",util.duration)
			end
			file:write(", Mana Costs: ",util.manaCost)
			file:write("\n")
			
		end
		file:write("\n")
	end
	file:close()
	

end