 


dependencies = {}


--[[
	Edit this table together with your new agent if it requires extern scripts
]]
dependencies.agents = {
	-- Without file extensions (.lua)
	["Phoenix"] = {
	},
	
	["Jett"] = {
	},
	
	["Veyne"] = {
	},
}

dependencies.extern = {
	-- With extensions!
	{"timerex.txt",	"https://www.unrealsoftware.de/files_show.php?file=13759"},
	{"unimenu.lua", "https://www.unrealsoftware.de/files_show.php?file=10921"},
}


function dependencies.init(dir)

	-- EXTERN SCRIPTS
	local color = "\169255100100Extern: "
	print("\169255255255Dofiling extern scripts. Make sure you installed them correctly or else the file will not be found!")
	for _,name in ipairs(dependencies.extern) do
		if (type(name) == "string") then
			print(color.."Dofile "..key.." "..name)
			dofile(dir.."extern/"..name)
		elseif (type(name) == "table") then
			print(color.."Dofile "..name[1])
			print("\169080080160Download at: "..name[2])
			dofile(dir.."extern/"..name[1])
		end
	end
	print("\169255255255Dofiling extern scripts done successfully! All files were found")
	
end


dependencies.done = {}

-- AGENT DEPENDENCIES
function dependencies.reload(dir, agent)
	if (dependencies.agents[agent] == nil) then
		-- agent does not need any dependencies
		return;
	end
	
	for _, dependency in pairs(dependencies.agents[agent]) do
		-- Not loaded already
		if (dependencies.done[dependency] == nil) then
			print("\169100100160Agent Dependency "..agent..": "..dependency)
			dofile(dir..dependency..".lua")
			dependencies.done[dependency] = 1 -- remember
		end
	end
end

