

--[[
	Basic Hooker - use myHooker:Hook(func, hook) to hook yourself.
	Or use an instance of 1 of hrwrapper's inherited Hooker classes
	to add conditional hooks
	- Do not use this, but use the versions used in hwrapper.lua	
	
	
]]






Hooker = {};
----------------------------------------------------------------------
-- Overrided by the wrappers!
----------------------------------------------------------------------
-- is current id correct agent?
function Hooker:CheckCall(fptr, data, ...)
	-- always call target function on normal Hooker
--	print("NORMAL :(")
	return fptr(unpack(arg))
end

function Hooker:Hook(func, hook)
	-- usually hookerType, hookerData, but here nil because we dont need it
	--print("Vanilla:Hook f("..tostring(func).." h("..hook..") type("..tostring(self))
	
	self:Add(func, hook, self, {})	
end
----------------------------------------------------------------------


-- Convenience function for :Hook
function Hooker:Set(list)
	for k,v in pairs(list) do
		if (v[3]) then
			self:Hook(v[1], v[2], v[3], v[4])
		else
			self:Hook(v[1], v[2])
		end
	end
end

-- Convenience function for :Hook
function Hooker:Unset(list)
	for k,v in pairs(list) do
		self:Remove(v[1], v[2])
	end
end



function Hooker:Remove(func, hook)
	-- Dictionaring
	if (conf.hookdict[hook]) then
		hook = conf.hookdict[hook]
	end
	
	-- Custom Hooks?
	if (conf.chooks[hook]) then
		cpool.remove(func, hook)
		return;
	end
	hpool.remove(func, hook)
end

-- Used by hpool
function Hooker:Call(fptr, data, hook, arg)
	return self:CheckCall(fptr, data, unpack(arg))
end 

-- used by hwrappers!
function Hooker:Add(func, hook, hookerType, data)
	--print("Hooker:Add: f("..tostring(func)..") h("..hook..") typ("..tostring(hookerType).." dat("..tostring(data))
	
	-- Dictionaring
	if (conf.hookdict[hook]) then
		hook = conf.hookdict[hook]
	end
	
	-- Custom Hooks?
	if (conf.chooks[hook]) then
		cpool.add(func, hook, hookerType, data)
		return;
	end
	
	hpool.add(func, hook, hookerType, data)
end


function Hooker:New(object)
	object = object or {};   				-- create object if user does not provide one
	setmetatable(object, self);
	self.__index = self; 
	object.list = {};
	return object;
end

