--[[
	Custom Hook Pool for custom hooks
	
	Please use hooker.lua!
	
	- stores all hook functions as functions
	- calls stored function on hook for custom hooks
]]


cpool = {}

cpool.hooks = {}


--[[
	Gets called by the guys that want to listen when "endbuy" occurs
]]
function cpool.add(func, hook, hooker, data_hooker)
	if (debug) then
		print("CPOOL: Add "..hook.." to "..tostring(func))
	end
	if (not cpool.hooks[hook]) then cpool.hooks[hook]= {} end
	table.insert(conf.chooks[hook], {fptr = func, data = data_hooker, hwrap = hooker})
end


--[[
	Gets called by the guy that triggers the "endbuy" event
]]
function cpool.trigger(hook, ...)
	arg = arg or {}
	for _,entry in pairs(conf.chooks[hook]) do
		entry.hwrap:Call(entry.fptr, entry.data, hook, arg)
	end
end


function cpool.remove(func, hook)
	for k,v in pairs(conf.chooks[hook]) do
		if (v.fptr==func) then
			table.remove(cpool.hooks[hook], k)
		end
	end
end

