--[[
	VALO 2D

	user.lua:
	- Stores generic agent data (amount of mana, ult points, etc)
	- Stores generic user data
]]--


if (not user) then
	user = {}
end

user.mapData = {}

user.data = {}

user.rounddata = {}



function user.saveSet(pid)
	local usgn = player(pid,"usgn")
	if (usgn) then
		user.mapData[usgn] = user.rounddata[pid]
	end
end


function user.createSet(pid)
	local usgn = player(pid,"usgn")
	
	-- Get old data (if any)
	if (user.mapData[usgn]) then
		user.rounddata[pid] = user.mapData[usgn];
		return;
	end
	
	-- Has selected agent?
	if (agents[agent.current[pid]]) then
		user.rounddata[pid] = {}
		user.rounddata[pid].agent = {}
		user.setRoundUser(pid)
	end
end


-- creates the default agent field for the user.data[]
function user.setRoundUser(pid)
	
	user.rounddata[pid].agent = {}
	user.rounddata[pid].agent.ultPoints = 0
	
	user.startround(pid)
	
end

function user.getSet(pid)
	return user.rounddata[pid].agent
end

function user.startround(pid)
	user.rounddata[pid].agent.utils = {}
	
	-- Refill mana
	user.rounddata[pid].agent.mana = conf.user.manaMax
	
	-- Refill util properties
	for _,key in ipairs(conf.user.utilKeys) do
		user.rounddata[pid].agent.utils[key] = {}
		user.rounddata[pid].agent.utils[key].cooldown = 0
		user.rounddata[pid].agent.utils[key].isActive = false
		user.rounddata[pid].agent.utils[key].usesLeft = agents[agent.current[pid]].utils[key].maxUse
	end
end
