
util = {}

--[[
	INPUT/ OUTPUT
]]
function util.isAdmin(pid)
	for _,adminid in pairs(conf.admins) do
		if (adminid == player(pid,"usgn")) then
			return true
		end
	end
	return false
end

function util.msg2(pid, color, txt)
	for _,val in ipairs(txt) do
		msg2(pid,color..val)
	end
end

function util.htxt2(pid, hid, txt, x, y, halign, valign, size)
	halign = halign or 0
	valign = valign or 0
	size = size or 10
	if (not txt) then
		parse("hudtxt2 "..pid.." "..hid)
		return;
	end
	parse('hudtxt2 '..pid..' '..hid..' "'..txt..'" '..x..' '..y..' '..halign..' '..valign..' '..size)
end

function util.htxt2duration(duration, pid, hid, txt, x, y, halign, valign, size)
	print("UTIL HTXT2DUR: "..duration)
	util.htxt2(pid,hid,txt,x,y,halign,valign,size)
	timerEx(duration, util.htxt2, 1, pid, hid)
end

function util.wpntype2killimg(wpntype)
	local name = itemtype(wpntype,"name")
	name = string.lower(name)
	return 'gfx/weapons/'..name..'_k.bmp'
end

--[[

	POSITIONING, GEOMETRY

]]
function util.direction2rotImg(x1,y1,x2,y2)
	local dx = x2 - x1
	local dy = y2 - y1
	local r
	local q = util._getQ(dx, dy)
	
	if (q <=2) then
		r = util.rad2deg(-math.atan(dx/dy))
	elseif (q >= 3) then
		r = -util.rad2deg(math.atan(dx/dy))+180
	end
	
	return r
end


function util._getQ(dx, dy)
	local q = {}
	local r = 360 
	if (dx > 0) then
		q = {1,4}
	else
		q = {2,3}
	end
	
	if (dy > 0) then
		for i,v in ipairs(q) do
			if (v == 1 or v == 2) then
				table.remove(q, i)
				break
			end
		end
	else
		for i,v in ipairs(q) do
			if (v == 3 or v == 4) then
				table.remove(q, i)
				break
			end
		end
	end
	
	return q[1]
	
end

-- direction <=> p1(x|y), p2(x|y)
-- returns cs2drot
function util.direction2rotPlayer(x1,y1, x2, y2)
	local dx = x2 - x1
	local dy = y2 - y1
	
	q = util._getQ(dx, dy)
	
	
	if (q == 1) then
		r = math.atan(dx / dy)
	elseif (q == 2) then
		r = -math.atan(dx / dy)
	elseif (q == 3) then
		r = math.atan(dx/dy)+180
	else
		r = 180-math.atan(dx/dy)
	end
--	r = math.atan(dx/dy)
	msg("q="..q..", dx="..dx..", dy="..dy..",r="..util.rad2deg(r))
	
	return util.rad2deg(r)
end

function util.rad2deg(value)
	return value*180/math.pi
end



function util.pixel2tile(number)
	local tile = 0
	
	while (number >= 32) do
		tile = tile +1
		number = number - 32
	end
	
	return tile
end
--[[
function pixel2tile(x, y)
	local result = {
		pixel2tile(x),
		pixel2tile(y),
	}
	return result;
end
]]

--[[
function tile2pixel(x, y)
	local result = {
		tile2pixel(x),
		tile2pixel(y),
	}
	return result
end
]]


--[[

	MATH

]]--

function util.tableMatch(tbl1, tbl2)
	local result = {};
	for _,e1 in pairs(tbl1) do
		for _,e2 in pairs(tbl2) do
			if (e1 == e2) then
				result[#result+1] = e1
				break
			end
		end
	
	end
	return result;
end

function util.getRandomNumber(min, max)
	return math.random(min,max)
end

function util.isBetween(num, lower, upper) 
	if (num > lower) then
		if (num < upper) then
			return true;
		end
	end
	return false;
end

--[[

	CS 2D

]]
function util.isEnemy(idMe, idTarget)
	return (player(idMe,"team") ~= player(idTarget,"team"))
end

function util.getPlayerOnTile(x, y)
	for _,id in pairs(player(0,"tableliving")) do
		if (player(id,"tilex") == x) then
			if (player(id,"tiley") == y) then
				return id;
			end
		end
	end
	return -1;
end

function util.getOppositeTeam(team)
	if (team >= 2) then
		return 1;
	end
	return 2;
end

--[[

	INIT

]]
function util.init()
	math.randomseed(os.time())
end


util.init()